/*global define*/
/*jslint browser:true*/
define([
    'testsuite/qunit',
    'testsuite/qunit-fixture!de_epages/taxus/inc/taxus-tools-test.html',
    'testsuite/qunit-fixture!de_epages/taxus/inc/taxus-tools-presence-test.html',
    'jquery',
    'de_epages/taxus/inc/taxus-tools',
    'ep/ui/form',
    '$dict!ep/dict',

    'jquery/metaparse',
    'ep/ui/validate',
    'ep/dict',
    'de_epages/presentation/ui/inputaction'
], function (QUnit, fixtureWizard, fixturePresence, $, taxusTools, ep, dict) {

    'use strict';

    var response = {
            complete: [{
                "ReportingCodeSpecialDistrict": "",
                "RateSpecialDistrict": 0,
                "PrimaryRecord": "0",
                "ShippingTaxable": "1",
                "County": "Shawnee",
                "City": "Security Benefit Life",
                "State": "KS",
                "ZipCode": "66636",
                "SalesTaxRate": 9.15,
                "RateCity": 1.5,
                "RateState": 6.5,
                "ReportingCodeState": "",
                "PostOffice": "Topeka",
                "Version": "2017-10",
                "RateCounty": 1.15,
                "ReportingCodeCity": "TOPSN",
                "ReportingCodeCounty": "SHACO",
                "z2t_ID": "57165"
            }, {
                "ReportingCodeSpecialDistrict": "",
                "RateSpecialDistrict": 0,
                "PrimaryRecord": "1",
                "ShippingTaxable": "1",
                "County": "Shawnee",
                "City": "Topeka",
                "State": "KS",
                "ZipCode": "66636",
                "SalesTaxRate": 9.15,
                "RateCity": 1.5,
                "RateState": 6.5,
                "ReportingCodeState": "",
                "PostOffice": "Topeka",
                "Version": "2017-10",
                "RateCounty": 1.15,
                "ReportingCodeCity": "TOPSN",
                "ReportingCodeCounty": "SHACO",
                "z2t_ID": "57166"
            }],
            incomplete: [{
                "ReportingCodeSpecialDistrict": "",
                "RateSpecialDistrict": 0,
                "PrimaryRecord": "1",
                "ShippingTaxable": "1",
                "County": "Shawnee",
                "City": "Topeka",
                "State": "KS",
                "ZipCode": "66630",
                "SalesTaxRate": 9.15,
                "RateCity": 1.5,
                "RateState": 6.5,
                "ReportingCodeState": "",
                "PostOffice": "Topeka",
                "Version": "2017-10",
                "RateCounty": 1.15,
                "ReportingCodeCity": "TOPSN",
                "ReportingCodeCounty": "SHACO",
                "z2t_ID": "555990"
            }, {
                "ReportingCodeSpecialDistrict": "",
                "RateSpecialDistrict": 0,
                "PrimaryRecord": "0",
                "ShippingTaxable": "1",
                "County": "Shawnee",
                "City": "Usps Critical Parts",
                "State": "KS",
                "ZipCode": "66630",
                "SalesTaxRate": 9.15,
                "RateCity": 1.5,
                "RateState": 6.5,
                "ReportingCodeState": "",
                "PostOffice": "Topeka",
                "Version": "2017-10",
                "RateCounty": 1.15,
                "ReportingCodeCity": "TOPSN",
                "ReportingCodeCounty": "SHACO",
                "z2t_ID": "555989"
            }, {
                "ReportingCodeSpecialDistrict": "",
                "RateSpecialDistrict": 0,
                "PrimaryRecord": "0",
                "ShippingTaxable": "1",
                "County": "Shawnee",
                "City": "Security Benefit Life",
                "State": "KS",
                "ZipCode": "66636",
                "SalesTaxRate": 9.15,
                "RateCity": 1.5,
                "RateState": 6.5,
                "ReportingCodeState": "",
                "PostOffice": "Topeka",
                "Version": "2017-10",
                "RateCounty": 1.15,
                "ReportingCodeCity": "TOPSN",
                "ReportingCodeCounty": "SHACO",
                "z2t_ID": "57165"
            }, {
                "ReportingCodeSpecialDistrict": "",
                "RateSpecialDistrict": 0,
                "PrimaryRecord": "1",
                "ShippingTaxable": "1",
                "County": "Shawnee",
                "City": "Topeka",
                "State": "KS",
                "ZipCode": "66636",
                "SalesTaxRate": 9.15,
                "RateCity": 1.5,
                "RateState": 6.5,
                "ReportingCodeState": "",
                "PostOffice": "Topeka",
                "Version": "2017-10",
                "RateCounty": 1.15,
                "ReportingCodeCity": "TOPSN",
                "ReportingCodeCounty": "SHACO",
                "z2t_ID": "57166"
            }]
        },

        address = {},
        address_840 = {
            street: {
                selector: '#'+'Street0',
                value: ''
            },
            zip: {
                selector: '#'+'Zipcode0',
                value: ''
            },
            city: {
                selector: '#'+'City0',
                value: ''
            },
            state: {
                selector: '#'+'State0',
                value: ''
            }
        },
        taxMatrixId = 20826,

        translations = {
            NOT_VALID: dict.translate('NOT_VALID'),
            NOT_IN_RANGELENGTH: dict.translate('NOT_IN_RANGELENGTH'),
            NO_ENTRY_SELECTED: dict.translate('NO_ENTRY_SELECTED')
        };


    ep.ajax = function (o) {
        var result = $.Deferred();

        if (o.data) {
            if (o.data.ChangeAction === 'JSONViewPresenceByZipCode') {
                // incomplete zip code
                if (o.data.ZipCode === "6663") {
                    result.resolve(response.incomplete);
                // complete zip code
                } else if (o.data.ZipCode === "66636") {
                    result.resolve(response.complete);
                // invalid zip code
                } else {
                    result.resolve([]);
                }
            } else if (o.data.ChangeAction === 'JSONDeleteTaxAreaUS') {
                if (o.data.ObjectID === taxMatrixId && o.data.PresenceID === 21377) {
                    QUnit.ok(
                        true,
                        'TEST (delete presence): Presence with TaxMatrixID ' + o.data.ObjectID + ' and PresenceID ' + o.data.PresenceID + ' was deleted.'
                    );

                    result.resolve();
                }
            }
        }

        return result;
    };

    QUnit.asyncTest("tools test presence of methods", function () {
        $.each([
            'taxusDeletePresence',
            'taxusAddPresence',
            'wizardAddAddress',
            'tooltip'
        ], function (i, fn) {
            QUnit.equal(
                $.isFunction(taxusTools[fn]),
                true,
                '$.isFunction(' + fn + '):'
            );
        });

        QUnit.start();
    });


    QUnit.asyncTest('Tax US tools (wizardAddAddress)', function () {
        // initialize fixture
        fixtureWizard.init();
        $('.ep-js').metaparse();

        var form = $('#ep-taxus-form'),
            wrapper = $('div.cityAndState'),
            zipcode = $(address_840.zip.selector),
            show = (address !== undefined && address.zip !== undefined && address.zip.value !== undefined && address.zip.value.length) ? true : false,

            widgetAutocomplete,
            widgetUiValidate,
            cityInput,
            stateInput;

        // fake form submit
        form.on('submit', function(evt) {
            //  prevent submitting the form
            evt.preventDefault();

            // mark for as submitted
            $(this).data('submitted', true);
        });

        taxusTools.wizardAddAddress(
            $.extend(address_840, {
                taxMatrixId: 20826,
                cityAndState: wrapper,
                spanCity: wrapper.find('span.city'),
                spanState: wrapper.find('span.state'),
                show: show,

                // callback - executed when an input occurs
                onBeforeSelect: function($zip) {
                    var validateWidget = $zip.data('uiUiValidate');

                    // if zip input is an uiValidate widget and is already initialized
                    if (validateWidget && $zip.data('initialized')) {
                        // set state of zip input invalid
                        validateWidget._setValidStatus(false);
                    }

                    // manually mark zip input as initialized
                    $zip.data('initialized', true);
                },
                // callback - executed after an entry was selected from the autocomplete list
                onAfterSelect: function($zip) {
                    var validateWidget = $zip.data('uiUiValidate');

                    if (validateWidget) {
                        // set state of zip input valid
                        validateWidget._setValidStatus(true);
                    }
                },
                // additional event handler - executed when the form.submit event triggers
                onSubmit: function(event, data) {
                    var $zip = data.zip,
                        autocompleteWidget = $zip.data('uiAutocomplete');

                    // if autocomplete widget exists and is invalid
                    if (autocompleteWidget && $zip.hasClass('ui-invalid')) {
                        // remove hidden inputs and display suggest list
                        data.setHiddenInputs();

                        // display autocomplete list if a search term exists
                        if (autocompleteWidget.term !== undefined) {
                            autocompleteWidget.menu.activeMenu.show();
                        }

                        // hide suggest list if invalid input
                        if (autocompleteWidget && autocompleteWidget.NOT_VALID) {
                          autocompleteWidget.menu.activeMenu.hide();
                        }
                    }
                }
            })
        );

        widgetAutocomplete = zipcode.data('uiAutocomplete');
        widgetUiValidate = zipcode.data('uiUiValidate');

        QUnit.ok(
            widgetAutocomplete!==undefined,
            'Autocomplet widget exists.'
        );

        // TEST: zip code (invalid characters)
        zipcode.val('asdf');
        zipcode.trigger('keydown');

        setTimeout(function () {
            QUnit.equal(
                widgetAutocomplete.menu.activeMenu.find('li').length,
                0,
                'TEST (invalid characters): Check number of returned zip codes (no response)'
            );

            form.trigger('submit');

            window.setTimeout(function() {
                QUnit.ok(
                    !widgetAutocomplete.menu.activeMenu.is(':visible'),
                    'TEST (invalid characters): Autocomplete list is not visible'
                );
                QUnit.ok(
                    widgetUiValidate.tooltip.data('uiUiTooltip').wrap.is(':visible'),
                    'TEST (invalid characters): Tooltip with error message is open'
                );
                QUnit.equal(
                    widgetUiValidate.errormsg[0].innerHTML,
                    translations['NOT_VALID'],
                    'TEST (invalid characters): Correct tooltip message: "' + translations['NOT_VALID'] +'"'
                );

                // TEST: zip code (not enough digits)
                zipcode.val('6663');
                zipcode.trigger('keydown');

                setTimeout(function () {
                    QUnit.equal(
                        widgetAutocomplete.menu.activeMenu.find('li').length,
                        response.incomplete.length,
                        'TEST (not enough digits): Check number of returned zip codes (incomplete, ' + response.complete.length + ' digits)'
                    );

                    form.trigger('submit');

                    window.setTimeout(function() {
                        QUnit.ok(
                            widgetAutocomplete.menu.activeMenu.is(':visible'),
                            'TEST (not enough digits): Autocomplete list is open'
                        );
                        QUnit.ok(
                            widgetUiValidate.tooltip.data('uiUiTooltip').wrap.is(':visible'),
                            'TEST (not enough digits): Tooltip with error message is open'
                        );
                        QUnit.equal(
                            widgetUiValidate.errormsg[0].innerHTML.substr(0, 10),
                            translations['NOT_IN_RANGELENGTH'].substr(0, 10),
                            'TEST (not enough digits): Correct tooltip message'
                        );

                        // test zip code (enough digits but no entry selected)
                        zipcode.val('66636');
                        zipcode.trigger('keydown');

                        setTimeout(function () {
                            QUnit.equal(
                                widgetAutocomplete.menu.activeMenu.find('li').length,
                                response.complete.length,
                                'TEST (enough digits, no entry selected): Check number of returned zip codes (complete, ' + response.complete.length + ' digits)'
                            );

                            form.trigger('submit');

                            window.setTimeout(function() {
                                QUnit.ok(
                                    widgetAutocomplete.menu.activeMenu.is(':visible'),
                                    'TEST (enough digits, no entry selected): Autocomplete list is open'
                                );
                                QUnit.ok(
                                    widgetUiValidate.tooltip.data('uiUiTooltip').wrap.is(':visible'),
                                    'TEST (enough digits, no entry selected): Tooltip with error message is open'
                                );
                                QUnit.equal(
                                    widgetUiValidate.errormsg[0].innerHTML,
                                    translations['NO_ENTRY_SELECTED'],
                                    'TEST (enough digits, no entry selected): Correct tooltip message (' + translations['NO_ENTRY_SELECTED'] + ')'
                                );

                                QUnit.ok(
                                    wrapper.hasClass('TextWeaker'),
                                    'TEST (enough digits, no entry selected): Wrapper for city and state get the class "TextWeaker" to mark as incomplete'
                                );

                                // choose first entry from suggest list
                                widgetAutocomplete.menu.activeMenu.find('li').eq(0).trigger('click');

                                // check selected values
                                QUnit.ok(
                                    !wrapper.hasClass('TextWeaker'),
                                    'TEST (success): Wrapper for city and state misses the class "TextWeaker" to mark as complete'
                                );
                                QUnit.equal(
                                    $(address_840.city.selector).val(),
                                    response.complete[0].City,
                                    'TEST (success): Correct city "' + response.complete[0].City + '" was inserted to hidden input.'
                                );
                                QUnit.equal(
                                    $(address_840.state.selector).val(),
                                    response.complete[0].State,
                                    'TEST (success): Correct state "' + response.complete[0].State + '"was inserted to hidden input.'
                                );

                                // delete content with inputaction
                                zipcode.data('uiPresentationUiInputaction').span.trigger('click');

                                // check selected values
                                QUnit.ok(
                                    wrapper.hasClass('TextWeaker'),
                                    'TEST (InputAction triggered): Wrapper for city and state get the class "TextWeaker" to mark as incomplete'
                                );

                                cityInput = $(address_840.city.selector);
                                stateInput = $(address_840.state.selector);

                                QUnit.ok(
                                    cityInput.val().length === 0,
                                    'TEST (InputAction triggered): Value of hidden input for city was resetted.'
                                );
                                QUnit.ok(
                                    stateInput.val().length === 0,
                                    'TEST (InputAction triggered): Value of hidden input for state was resetted.'
                                );


                                QUnit.equal(
                                    zipcode.val().length,
                                    0,
                                    'TEST (InputAction triggered): Zip code was removed.'
                                );

                                // test zip code (enough digits but no entry selected)
                                zipcode.val('66636');
                                zipcode.trigger('keydown');

                                setTimeout(function () {

                                    // choose first entry from suggest list
                                    widgetAutocomplete.menu.activeMenu.find('li').eq(0).trigger('click');

                                    form.trigger('submit');

                                    QUnit.ok(
                                        form.data('submitted') !== undefined && form.data('submitted') === true,
                                        'TEST (form submit): Form was submitted'
                                    );

                                    // destroy fixture
                                    fixturePresence.destroy();
                                    // start tests
                                    QUnit.start();
                                }, 350);
                            }, 300);
                        }, 350);
                    }, 300);
                }, 350);
            }, 300);
        }, 350);

    });


    QUnit.asyncTest('Tax US tools (add/remove presence)', function () {
        // initialize fixture
        fixturePresence.init();
        $('.ep-js').metaparse();

        var form = $('#ep-taxus-form'),
            zipcode = $('#ZipCode'),
            show = (address !== undefined && address.zip !== undefined && address.zip.value !== undefined && address.zip.value.length) ? true : false,

            widgetAutocomplete,
            widgetTooltip,
            tooltip,

            cityInput,
            stateInput,
            zipcodeInput;

        // fake form submit
        form.on('submit', function(evt, additional) {
            //  prevent submitting the form
            evt.preventDefault();
            // mark for as submitted
            $(this).data('submitted', true);
        });

        taxusTools.taxusAddPresence({
            taxMatrixId: taxMatrixId,
            zip: $('input[name=ZipCode]'),

            // callback - executed when an input occurs
            onBeforeSelect: function($zip) {
                // mark zip input as invalid
                $zip.data('isInvalid', true);
            },
            // callback - executed after an entry was selected from the autocomplete list
            onAfterSelect: function($zip) {
                // mark zip input as invalid
                $zip.data('isInvalid', false);
            },
            onSubmit: function(event, data) {
              var $zip = data.zip,
                  autocompleteWidget = $zip.data('uiAutocomplete');

                // if autocomplete widget exists and is invalid
                if (autocompleteWidget && $zip.val().length && $zip.data('isInvalid') !== undefined && $zip.data('isInvalid')===true) {
                    event.preventDefault();

                    // show tooltip
                    taxusTools.tooltip({
                        message: (autocompleteWidget && autocompleteWidget.NOT_VALID) ? translations.NOT_VALID : translations.NO_ENTRY_SELECTED,
                        interactiveElement: $('body'),
                        context: $zip,
                        orientation: 'top middle'
                    });

                    // display suggest list
                    if (autocompleteWidget.term !== undefined) {
                        autocompleteWidget.menu.activeMenu.show();
                    }

                    // hide suggest list if invalid input
                    if (autocompleteWidget && autocompleteWidget.NOT_VALID) {
                        autocompleteWidget.menu.activeMenu.hide();
                    }

                    // remove hidden inputs
                    data.setHiddenInputs();
              }
            }
        });

        taxusTools.taxusDeletePresence('.deleteTaxArea', taxMatrixId);

        widgetAutocomplete = zipcode.data('uiAutocomplete');

        QUnit.ok(
            widgetAutocomplete!==undefined,
            'Autocomplete widget exists.'
        );

        // TEST: zip code (invalid characters)
        zipcode.val('asdf');
        zipcode.trigger('keydown');

        setTimeout(function () {
            QUnit.equal(
                widgetAutocomplete.menu.activeMenu.find('li').length,
                0,
                'TEST (invalid characters): Check number of returned zip codes (no response)'
            );

            form.trigger('submit');

            window.setTimeout(function() {
                tooltip = $('.ep-taxus-tools-tooltip');
                widgetTooltip = tooltip.data('uiUiTooltip');

                QUnit.ok(
                    !widgetAutocomplete.menu.activeMenu.is(':visible'),
                    'TEST (invalid characters): Autocomplete list is not visible'
                );
                QUnit.ok(
                    widgetTooltip.wrap.is(':visible'),
                    'TEST (invalid characters): Tooltip with error message is open'
                );
                QUnit.equal(
                    widgetTooltip.element[0].innerHTML,
                    translations['NOT_VALID'],
                    'TEST (invalid characters): Correct tooltip message: "' + translations['NOT_VALID'] +'"'
                );

                // TEST: zip code (not enough digits)
                zipcode.val('6663');
                zipcode.trigger('keydown');

                setTimeout(function () {
                    QUnit.equal(
                        widgetAutocomplete.menu.activeMenu.find('li').length,
                        response.incomplete.length,
                        'TEST (not enough digits): Check number of returned zip codes (incomplete, ' + response.complete.length + ' digits)'
                    );

                    form.trigger('submit');

                    window.setTimeout(function() {
                        QUnit.ok(
                            widgetAutocomplete.menu.activeMenu.is(':visible'),
                            'TEST (not enough digits): Autocomplete list is open'
                        );
                        QUnit.ok(
                            widgetTooltip.wrap.is(':visible'),
                            'TEST (not enough digits): Tooltip with error message is open'
                        );
                        QUnit.equal(
                            widgetTooltip.element[0].innerHTML,
                            translations['NO_ENTRY_SELECTED'],
                            'TEST (not enough digits): Correct tooltip message'
                        );

                        cityInput = $('input[name="Zip2TaxCity"]');
                        stateInput = $('input[name="Zip2TaxState"]');
                        zipcodeInput = $('input[name="Zip2TaxZipCode"]');

                        QUnit.ok(
                            cityInput.length === 0,
                            'TEST (not enough digits): No hidden input for city exists.'
                        );
                        QUnit.ok(
                            stateInput.length === 0,
                            'TEST (not enough digits): No hidden input for state exists.'
                        );
                        QUnit.ok(
                            zipcodeInput.length === 0,
                            'TEST (not enough digits): No hidden input for zipcode exists.'
                        );

                        // test zip code (enough digits but no entry selected)
                        zipcode.val('66636');
                        zipcode.trigger('keydown');

                        setTimeout(function () {
                            QUnit.equal(
                                widgetAutocomplete.menu.activeMenu.find('li').length,
                                response.complete.length,
                                'TEST (enough digits, no entry selected): Check number of returned zip codes (complete, ' + response.complete.length + ' digits)'
                            );

                            form.trigger('submit');

                            window.setTimeout(function() {
                                QUnit.ok(
                                    widgetAutocomplete.menu.activeMenu.is(':visible'),
                                    'TEST (enough digits, no entry selected): Autocomplete list is open'
                                );
                                QUnit.ok(
                                    widgetTooltip.wrap.is(':visible'),
                                    'TEST (enough digits, no entry selected): Tooltip with error message is open'
                                );
                                QUnit.equal(
                                    widgetTooltip.element[0].innerHTML,
                                    translations['NO_ENTRY_SELECTED'],
                                    'TEST (enough digits, no entry selected): Correct tooltip message (' + translations['NO_ENTRY_SELECTED'] + ')'
                                );

                                // choose first entry from suggest list
                                widgetAutocomplete.menu.activeMenu.find('li').eq(0).trigger('click');

                                cityInput = $('input[name="Zip2TaxCity"]');
                                stateInput = $('input[name="Zip2TaxState"]');
                                zipcodeInput = $('input[name="Zip2TaxZipCode"]');

                                QUnit.ok(
                                    cityInput.length === 1,
                                    'TEST (success): Hidden input for city exists.'
                                );
                                QUnit.ok(
                                    stateInput.length === 1,
                                    'TEST (success): Hidden input for state exists.'
                                );
                                QUnit.ok(
                                    zipcodeInput.length === 1,
                                    'TEST (success): Hidden input for zipcode exists.'
                                );

                                // check selected values
                                QUnit.equal(
                                    cityInput.val(),
                                    response.complete[0].City,
                                    'TEST (success): Correct city was inserted: "' + response.complete[0].City + '"'
                                );
                                QUnit.equal(
                                    stateInput.val(),
                                    response.complete[0].State,
                                    'TEST (success): Correct state was inserted: "' + response.complete[0].State + '"'
                                );

                                // delete content with inputaction
                                zipcode.data('uiPresentationUiInputaction').span.trigger('click');

                                cityInput = $('input[name="Zip2TaxCity"]');
                                stateInput = $('input[name="Zip2TaxState"]');
                                zipcodeInput = $('input[name="Zip2TaxZipCode"]');

                                QUnit.ok(
                                    cityInput.length === 0,
                                    'TEST (InputAction triggered): No hidden input for city exists.'
                                );
                                QUnit.ok(
                                    stateInput.length === 0,
                                    'TEST (InputAction triggered): No hidden input for state exists.'
                                );
                                QUnit.ok(
                                    zipcodeInput.length === 0,
                                    'TEST (InputAction triggered): No hidden input for zipcode exists.'
                                );

                                // test zip code (enough digits but no entry selected)
                                zipcode.val('66636');
                                zipcode.trigger('keydown');

                                setTimeout(function () {

                                    // choose first entry from suggest list
                                    widgetAutocomplete.menu.activeMenu.find('li').eq(0).trigger('click');

                                    QUnit.equal(
                                        zipcode.val(),
                                        response.complete[0].ZipCode + ' - ' + response.complete[0].City + ', ' + response.complete[0].County + ', ' + response.complete[0].State,
                                        'TEST (InputAction triggered): Correct address was inserted (' + response.complete[0].ZipCode + ' - ' + response.complete[0].City + ', ' + response.complete[0].County + ', ' + response.complete[0].State +')'
                                    );

                                    form.trigger('submit');

                                    QUnit.ok(
                                        form.data('submitted') !== undefined && form.data('submitted') === true,
                                        'TEST (form submit): Form was submitted'
                                    );

                                    QUnit.ok(
                                        $('table tbody tr').eq(0).is(':visible'),
                                        'TEST (delete presence): One presence is set.'
                                    );

                                    $('.deleteTaxArea').trigger('click');

                                    window.setTimeout(function() {
                                        QUnit.ok(
                                            !$('table tbody tr').eq(0).is(':hidden'),
                                            'TEST (delete presence): Presence was deleted.'
                                        );

                                        // destroy fixture
                                        fixturePresence.destroy();
                                        // start tests
                                        QUnit.start();
                                    }, 350);
                                }, 350);
                            }, 300);
                        }, 350);
                    }, 300);
                }, 350);
            }, 300);
        }, 350);

    });
});
